UTI: Export results
[csit.git] / resources / libraries / bash / function / common.sh
index ff632a2..0a4c949 100644 (file)
@@ -147,7 +147,8 @@ function archive_tests () {
 
     set -exuo pipefail
 
-    tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
+    filename="generated_robot_files.tar.xz"
+    tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/${filename}" || {
         die "Error creating archive of generated tests."
     }
 }
@@ -606,6 +607,7 @@ function prepare_topology () {
     # Prepare virtual testbed topology if needed based on flavor.
 
     # Variables read:
+    # - TEST_CODE - String affecting test selection, usually jenkins job name.
     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
     # Functions called:
@@ -618,10 +620,12 @@ function prepare_topology () {
     case_text="${NODENESS}_${FLAVOR}"
     case "${case_text}" in
         "2n_aws")
+            export TF_VAR_testbed_name="${TEST_CODE}"
             terraform_init || die "Failed to call terraform init."
             terraform_apply || die "Failed to call terraform apply."
             ;;
         "3n_aws")
+            export TF_VAR_testbed_name="${TEST_CODE}"
             terraform_init || die "Failed to call terraform init."
             terraform_apply || die "Failed to call terraform apply."
             ;;
@@ -710,6 +714,8 @@ function run_pybot () {
 
     # Run pybot with options based on input variables. Create output_info.xml
     #
+    # Also, .info.json files are moved into an archive to speed up PAL.
+    #
     # Variables read:
     # - CSIT_DIR - Path to existing root of local CSIT git repository.
     # - ARCHIVE_DIR - Path to store robot result files in.
@@ -732,7 +738,31 @@ function run_pybot () {
     PYBOT_EXIT_STATUS="$?"
     set -e
 
+    # Compress raw json outputs, if any.
+    pushd "${ARCHIVE_DIR}" || die
+    if [ -d "tests" ]; then
+        # Use deterministic order.
+        options+=("--sort=name")
+        # We are keeping info outputs where they are.
+        # Assuming we want to move anything but info files (and dirs).
+        options+=("--exclude=*.info.json")
+        # There may be other unforeseen errors,
+        # we still want to execute subsequent commands, so disable set -e.
+        set +e
+        tar cvf "tests_output_raw.tar" "${options[@]}" "tests"
+        # If compression fails, it leaves an uncompressed .tar,
+        # we still want to archive that to investigate why compression failed.
+        time xz -9e "tests_output_raw.tar"
+        # Tar can remove when archiving, but chokes (not deterministically)
+        # on attempting to remove dirs (not empty as info files are there).
+        # So we need to delete the raw files manually.
+        find "tests" -type f -name "*.raw.json" -delete
+        set -e
+    fi
+    popd || die
+
     # Generate INFO level output_info.xml for post-processing.
+    # This comes last, as it is slowest, and sometimes users abort here.
     all_options=("--loglevel" "INFO")
     all_options+=("--log" "none")
     all_options+=("--report" "none")
@@ -858,7 +888,9 @@ function select_tags () {
     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
     awk_nics_sub_cmd+='else if ($9 =="drv_af_xdp") drv ="af-xdp-";'
     awk_nics_sub_cmd+='else drv="";'
-    awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-"$1"-" drv $11"-"$5'
+    awk_nics_sub_cmd+='if ($1 =="-") cores="";'
+    awk_nics_sub_cmd+='else cores=$1;'
+    awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-" cores "-" drv $11"-"$5'
 
     # Tag file directory shorthand.
     tfd="${JOB_SPECS_DIR}"
@@ -931,6 +963,10 @@ function select_tags () {
         *"1n-vbox"*)
             test_tag_array+=("!avf")
             test_tag_array+=("!vhost")
+            test_tag_array+=("!flow")
+            ;;
+        *"1n_tx2"*)
+            test_tag_array+=("!flow")
             ;;
         *"2n-skx"*)
             test_tag_array+=("!ipsechw")
@@ -1113,6 +1149,7 @@ function set_environment_variables () {
             # T-Rex 2.88 workaround for ENA NICs
             export TREX_RX_DESCRIPTORS_COUNT=1024
             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
+            export TREX_CORE_COUNT=6
             # Settings to prevent duration stretching
             export PERF_TRIAL_STL_DELAY=0.1
             ;;